<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color:white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="black"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
    <!-- spinner -->

    <!-- icon-top-onScroll -->
    <v-btn
      v-scroll="onScroll"
      v-show="fab"
      fab
      dark
      fixed
      bottom
      right
      color="#428bca"
      @click="toTop"
    >
      <v-icon>mdi-chevron-up</v-icon>
    </v-btn>
    <!-- icon-top-onScroll -->

    <!-- table api -->
    <v-row>
      <v-col cols="12" lg="12" md="12" sm="12">
        <v-card>
          <v-container grid-list-xs>
            <v-row>
              <v-col cols="12" lg="12" md="12" sm="12">
                <v-card-title>
                  <h1>
                    API
                  </h1>
                </v-card-title>
                <div>
                  <v-card-title>
                    <v-btn
                      class="mr-1"
                      @click="dialog_add_api = true"
                      type="button"
                      color="#428bca"
                      small
                      dark
                      ><v-icon small class="pr-1">mdi-plus</v-icon>Add
                      API</v-btn
                    >
                    <v-spacer></v-spacer>
                    <v-text-field
                      v-model="search"
                      append-icon="mdi-magnify"
                      label="Search"
                      single-line
                      hide-details
                    ></v-text-field>
                  </v-card-title>
                  <v-data-table
                    :headers="headers"
                    :items="all_api"
                    :search="search"
                  >
                    <template v-slot:item.actions="{ item }">
                      <v-tooltip top>
                        <template v-slot:activator="{ on, attrs }">
                          <v-icon
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-0"
                            @click="edit_api(item)"
                            color="teal"
                          >
                            mdi-pencil
                          </v-icon>
                        </template>
                        <span>Edit</span>
                      </v-tooltip>
                      &nbsp;&nbsp;
                      <v-tooltip top>
                        <template v-slot:activator="{ on, attrs }">
                          <v-icon
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-0"
                            @click="delete_api(item)"
                            color="error"
                          >
                            mdi-delete
                          </v-icon>
                        </template>
                        <span>Delete</span>
                      </v-tooltip>
                    </template>
                  </v-data-table>
                </div>
              </v-col>
            </v-row>
          </v-container>
        </v-card>
      </v-col>
    </v-row>
    <!-- table api -->

    <!-- dialog_add_api -->
    <v-dialog v-model="dialog_add_api" max-width="500px" persistent>
      <v-card>
        <v-card-title class="headline" style="color:white;background:#428bca">
          Add API
        </v-card-title>
        <v-form ref="form_add">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_add_api.api_name"
                    :rules="form_add_api.api_nameRules"
                    label="	API Name"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_add_api.link_api"
                    :rules="form_add_api.link_apiRules"
                    label="Link API"
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancel_add" style="color: white;">
            Cancel
          </v-btn>
          <v-btn color="blue" @click="save_add" style="color: white;">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_add_api -->

    <!-- dialog_edit_api -->
    <v-dialog v-model="dialog_edit_api" max-width="500px" persistent>
      <v-card>
        <v-card-title class="headline" style="color:white;background:#428bca">
          Edit API
        </v-card-title>
        <v-form ref="form_edit">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_edit_api.api_name"
                    :rules="form_add_api.api_nameRules"
                    label="	API Name"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_edit_api.link_api"
                    :rules="form_add_api.link_apiRules"
                    label="Link API"
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn
            color="red"
            @click="dialog_edit_api = false"
            style="color: white;"
          >
            Cancel
          </v-btn>
          <v-btn color="blue" @click="save_edit" style="color: white;">
            Update
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_edit_hospital -->
  </v-app>
</template>

<script>
export default {
  name: "API",
  data() {
    return {
      fab: false,
      dialog_add_api: false,
      dialog_edit_api: false,
      dialog_delete_api: false,
      dialog_loader: false,
      search: "",
      all_api: [
        {
          api_name: "Pneumothorax",
          link_api: "http://103.138.176.15:5004/pneumothorax",
        },
        {
          api_name: "Emphysema",
          link_api: "http://103.138.176.15:5002/emphysema",
        },
        {
          api_name: "Abnormal",
          link_api: "http://103.138.176.15:5005/abnormal",
        },
        {
          api_name: "Tuberculosis",
          link_api: "http://103.138.176.15:5000/tuberculosis",
        },
      ],
      headers: [
        {
          text: "API Name",
          align: "start",
          value: "api_name",
          sortable: false,
        },
        {
          text: "Link API",
          align: "start",
          value: "link_api",
          sortable: false,
        },
        { text: "Action", value: "actions", sortable: false },
      ],
      form_add_api: {
        api_name: "",
        api_nameRules: [(v) => !!v || "Please enter API Name"],
        link_api: "",
        link_apiRules: [(v) => !!v || "Please enter Link API"],
      },
      form_edit_api: {},
      session_id: this.$cookies.get("info_login").session_id,
    };
  },

  methods: {
    onScroll(e) {
      if (typeof window === "undefined") return;
      const top = window.pageYOffset || e.target.scrollTop || 0;
      this.fab = top > 20;
    },

    toTop() {
      this.$vuetify.goTo(0);
    },

    cancel_add() {
      this.$refs.form_add.reset();
      this.dialog_add_api = false;
    },

    save_add() {
      if (!this.$refs.form_add.validate()) return;
      this.dialog_add_api = false;
      this.$refs.form_add.reset();
      this.$swal({
        icon: "success",
        title: "Success!",
        text: "Add API success.",
        confirmButtonText: "OK",
        allowOutsideClick: false,
      });
    },

    edit_api(item) {
      this.form_edit_api = item;
      this.dialog_edit_api = true;
    },

    save_edit() {
      if (!this.$refs.form_edit.validate()) return;
      this.dialog_edit_api = false;
      // console.log(this.form_edit_api);
      this.$swal({
        icon: "success",
        title: "Success!",
        text: "Edit API success.",
        confirmButtonText: "OK",
        allowOutsideClick: false,
      });
    },

    delete_api(item) {
      console.log(item);
      // this.dialog_delete_api = true;
      this.$swal({
        title: "Are you sure?",
        text: "You want to delete API!",
        icon: "warning",
        showCancelButton: true,
        allowOutsideClick: false,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Yes",
      }).then((result) => {
        if (result.value) {
          this.$swal({
            icon: "success",
            title: "Success!",
            text: "Delete API success.",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          });
        }
      });
    },
  },
};
</script>

<style></style>
